<script setup lang="ts">
import { ref, nextTick, onMounted } from 'vue'

import { type Stock } from '@/types/Stock'
import type { VForm } from 'vuetify/components'

import http from '@/services/http'

//store
import { useStockStore } from '@/stores/checkstock'
import UploadUserImage from '@/components/UploadUserImage.vue'

const stockStore = useStockStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const loading = ref(false)

let lastId = 4
let editedIndex = -1
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Username',
    key: 'user',
    value: 'user'
  },
  {
    title: 'Password',
    key: 'password',
    value: 'password'
  },
  {
    title: ' Name',
    key: 'fullName',
    value: 'fullName'
  },
  {
    title: 'Email',
    key: 'email',
    value: 'email'
  },
  {
    title: 'Telephone',
    key: 'tel',
    value: 'tel'
  },
  {
    title: 'Address',
    key: 'address',
    value: 'address'
  },
  {
    title: 'Rank',
    key: 'rank',
    value: 'rank'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

function onSubmit() {
  // Implement your form submission logic here
}
function closeDialog() {
  stockStore.dialog = false
  nextTick(() => {
    userStore.editedUser = Object.assign({}, stockStore.initiUser)
  })
}
onMounted(() => {
  userStore.getUsers
})

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  await userStore.saveUser(userStore.editedUser)
  closeDialog()
}
</script>

<template>
  <div>
    <br />
    <v-data-table :headers="headers" :items="userStore.users">
      <template v-slot:top>
        <v-toolbar flat class="bg-blue">
          <v-toolbar-title>Users</v-toolbar-title>
          <v-divider
            class="mx-4 border-opacity-75"
            inset
            vertical
            thickness="2"
            color="white"
          ></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="userStore.dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props" icon="mdi-account-plus" class="bg-white">
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">User Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="userStore.editedUser.fullName"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Full Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="userStore.editedUser.email"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Email"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="userStore.editedUser.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Phone Number"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12">
                        <v-text-field
                          v-model="userStore.editedUser.address"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Address"
                          single-line
                        ></v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="userStore.editedUser.user"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="User Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="userStore.editedUser.password"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Password"
                          placeholder="Enter your password"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          label="Select Rank"
                          :items="['ผู้จัดการ', 'พนักงาน']"
                          v-model="userStore.editedUser.rank"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          v-model="userStore.editedUser.status"
                          label="Select Roles"
                          :items="[
                            { title: 'Active', value: 'Active' },
                            { title: 'Inactive', value: 'Inactive' }
                          ]"
                          :return-object="false"
                        ></v-combobox>
                      </v-col>
                    </v-row>
                    <v-row>
                      <UploadUserImage></UploadUserImage>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="userStore.dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="userStore.closeDelete"
                  >Cancel</v-btn
                >
                <v-btn color="blue-darken-1" variant="text" @click="userStore.deleteItemConfirm"
                  >OK</v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <div>{{ item.id }}</div>
        <v-icon size="small" class="me-2" @click="userStore.editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="userStore.deleteUserConfirm(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="userStore.getUsers"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
@/stores/stock
